<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--机构数据-->
      <el-col :span="4" :xs="24">
        <org-tree v-model="queryParams.orgId" @defaultKey="getDefaultKey" @checkChange="checkChange"
                  @click="clickTreeNode" hangsheTree></org-tree>
      </el-col>
      <el-col :span="20" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="编号" prop="id">
            <el-input v-model="queryParams.id" placeholder="请输入编号" clearable
                      @keyup.enter.native="handleQuery"/>
          </el-form-item>
          <el-form-item label="演练类型" prop="drillType">
            <el-select v-model="queryParams.drillType" placeholder="请选择演练类型" clearable>
              <el-option
                v-for="dict in dict.type.core_drill_type"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['core:drillDictionary:add']"
            >新增
            </el-button>
          </el-col>
<!--          <el-col :span="1.5">
            <el-button
              type="warning"
              plain
              icon="el-icon-download"
              size="mini"
              @click="handleExport"
              v-hasPermi="['core:drillDictionary:export']"
            >导出
            </el-button>
          </el-col>-->
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="drillDictionaryList" @selection-change="handleSelectionChange">
          <el-table-column label="编号" align="center" prop="id"/>
          <el-table-column label="机构名称" align="center" prop="orgName" />           
          
          <el-table-column label="演练类型" align="center" prop="drillType">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.core_drill_type" :value="scope.row.drillType"/>
            </template>
          </el-table-column>
          <el-table-column  label="解决方案" scoped-slot="drillProjects" align="center" prop="drillProjects">
            <template slot-scope="scope">
              <div class="ellipsis" :title="scope.row.drillProjects">{{ scope.row.drillProjects }}</div>
            </template>
          </el-table-column>
          <el-table-column  label="预设案由" scoped-slot="defaultCause" align="center" prop="defaultCause">
            <template slot-scope="scope">
              <div class="ellipsis" :title="scope.row.defaultCause">{{ scope.row.defaultCause }}</div>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-edit"
                v-if="canEdit(scope.row)"
                @click="handleUpdate(scope.row)"
                v-hasPermi="['core:drillDictionary:edit']"
              >修改
              </el-button>
              <BtnTip
                size="mini"
                type="text"
                icon="el-icon-delete"
                v-if="canDelete(scope.row)"
                @click="handleDelete(scope.row)"
                v-hasPermi="['core:drillDictionary:remove']"
              >删除
              </BtnTip>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </el-col>
    </el-row>
    <!-- 添加或修改预案演练库对话框 -->
    <DialogCom :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="演练类型" prop="drillType" style="width:100%;">
          <el-select v-model="form.drillType" placeholder="请选择演练类型" style="width:100%;">
            <el-option
              v-for="dict in dict.type.core_drill_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="解决方案" prop="drillProjects">
          <el-input v-model="form.drillProjects" maxlength="50"  placeholder="请输入解决方案"/>
        </el-form-item>
        <el-form-item label="预设案由" prop="defaultCause">
          <el-input v-model="form.defaultCause" maxlength="2000" :rows="6" 
  show-word-limit type="textarea" placeholder="请输入预设案由"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </DialogCom>
  </div>

</template>

<script>
import {
  listDrillDictionary,
  getDrillDictionary,
  delDrillDictionary,
  addDrillDictionary,
  updateDrillDictionary
} from "@/api/core/drill/drillDictionary";
import OrgTree from "@/components/orgTree";
import BtnTip from "@/components/btnTip";
import KFileUpload from "@/components/K-FileUpload";
import tableList from "@/mixins/tableList";
import {queryKnowledgeList} from "@/api/core/edu/knowledge";
export default {
  name: "DrillDictionary",
  components: {OrgTree,BtnTip},
  dicts: ['core_drill_type'],
  mixins: [tableList],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 预案演练库表格数据
      drillDictionaryList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        drillType: null,
        drillTypeName: null,
        drillProjects: null,
        defaultCause: null,
        checkSub:true
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        drillType: [{ required: true, message: "请选择演练类型" }],
        drillProjects: [{ required: true, message: "请输入解决方案名称" }],
        defaultCause: [{ required: true, message: "请输入预设案由" }],
      }
    };
  },
  created() {
    // this.getList();
  },
  methods: {
    /** 查询预案演练库列表 */
    getList() {
      this.loading = true;
      listDrillDictionary(this.queryParams).then(response => {
        this.drillDictionaryList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        orgId: this.queryParams.orgId,
        drillType: null,
        drillProjects: null,
        defaultCause: null,
        checkSub:true,
      };
      this.resetForm("form");
    },
    getDefaultKey(key) {
      this.queryParams.orgId = key;
      this.getList();
    },
    //单选框状态改变
    checkChange(state) {
      this.queryParams.checkSub = state;
      this.handleQuery();
    },

    // 节点单击事件
    clickTreeNode(data) {
      this.queryParams.orgId = data.id;
      this.handleQuery();
    },
    initKnowledgeList() {
      queryKnowledgeList().then(response => {
        this.knowledgeList = response;
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加参考预案演练库";
    },
    canEdit(row)
    {
      return row.orgId == this.$store.getters.orgId;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getDrillDictionary(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改参考预案演练库";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateDrillDictionary(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDrillDictionary(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    canDelete(row)
    {
      return row.orgId == this.$store.getters.orgId;
    },
    
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      delDrillDictionary(ids).then(response => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
    }).catch(() => {
        this.$modal.msgSuccess("删除失败");
      });
      // this.$modal.confirm('是否确认删除预案演练库编号为"' + ids + '"的数据项？').then(function () {
      //   return delDrillDictionary(ids);
      // }).then(() => {
      //   this.getList();
      //   this.$modal.msgSuccess("删除成功");
      // }).catch(() => {
      // });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('core/drillDictionary/export', {
        ...this.queryParams
      }, `drillDictionary_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style>
.ellipsis {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
</style>
